#include "glload.h"
#ifdef linux

#include <stdio.h>
#include <fcntl.h>

#else

#include <stdio.h>
#include <sys/param.h>
#include <rpcsvc/rstat.h>

#ifdef SVR4

#include <netdb.h>

#ifndef FSCALE
#define FSCALE	(1 << 8)
#endif

struct statstime res;

#endif

#endif
char hostname[255] =
{""};


#ifdef linux
/* linux version */
void 
GetLoad (float *small, float *medium, float *large)
{
  char buffer[100];
  int fd, len;
  int total;
  char *p;

  fd = open ("/proc/loadavg", O_RDONLY);
  len = read (fd, buffer, sizeof (buffer) - 1);
  close (fd);
  buffer[len] = '\0';

  sscanf (buffer, "%f%f%f", small, medium, large);
  /* pas de verif ... */
}

#endif

#ifdef SVR4
/* SVR4 */
void 
GetLoad (float *small, float *medium, float *large)
{
  /*
   * originally written by Matthieu Herrb - Mon Oct  5 1992
   * modified for optimization
   */

  if (rstat (hostname, &res) != 0) {
    perror ("rstat");
    *small = *medium = *large = 0.0;
    return;
  }
  *small = (float) res.avenrun[0] / FSCALE;
  *medium = (float) res.avenrun[1] / FSCALE;
  *large = (float) res.avenrun[2] / FSCALE;
}

#endif

#ifdef FreeBSD

#include <stdio.h>
#include <sys/param.h>
#include <sys/fcntl.h>

void 
GetLoad (float *small, float *medium, float *large)
{
  double avenrun[3];
  int i;

  getloadavg (avenrun, sizeof (avenrun) / sizeof (avenrun[0]));

  *small = (float) avenrun[0];
  *medium = (float) avenrun[1];
  *large = (float) avenrun[2];
}

#endif
/*
 * $Log: get_load.c,v $
 * Revision 1.3  2000/03/08 13:09:21  eilemann
 * inserted cvs log in all files
 *
 */
