
/*
 * Pass the x and y coordinates of the last and current positions of
 * the mouse, scaled so they are from (-1.0 ... 1.0).
 *
 * The resulting rotation is returned as a quaternion rotation in the
 * first paramater.
 */
void
trackball(float q[4], float p1x, float p1y, float p2x, float p2y);

/*
 * Given two quaternions, add them together to get a third quaternion.
 * Adding quaternions to get a compound rotation is analagous to adding
 * translations to get a compound translation.  When incrementally
 * adding rotations, the first argument here should be the new
 * rotation, the second and third the total rotation (which will be
 * over-written with the resulting new total rotation).
 */
void
add_quats(float *q1, float *q2, float *dest);

/*
 * A useful function, builds a rotation matrix in Matrix based on
 * given quaternion.
 */
void
build_rotmatrix(float m[4][4], float q[4]);

/*
 * This function computes a quaternion based on an axis (defined by
 * the given vector) and an angle about which to rotate.  The angle is
 * expressed in radians.  The result is put into the third argument.
 */
void
axis_to_quat(float a[3], float phi, float q[4]);

/*
 *  Reads from the frame buffer and writes to a Targa file.  
 */
int screenShot (char *fName, int winW, int winH);
/* texture.h - by David Blythe, SGI */

/* Simple SGI .rgb image file loader routine. */

unsigned *
read_texture(char *name, int *width, int *height, int *components);
void GetLoad (float *, float *, float *);
/*
 * $Log: glload.h,v $
 * Revision 1.3  2000/03/08 13:09:21  eilemann
 * inserted cvs log in all files
 *
 */
 
