#include <stdio.h>
#include <stdlib.h>
#include "glload.h"
#include <GL/glut.h>
/*
	Function -- makeBGR
	Converts a RGB buffer to BGR
*/
void makeBGR (unsigned char *p, int size) {
	unsigned char temp;
	int i;

	for (i = 0; i < size * 3; i += 3) {
		temp = p[i];
		p[i] = p[i + 2];
		p[i + 2] = temp;
	}
}
/*
	Function -- writeTGA
	Writes a buffer to a .tga file, buffer should be RGB
*/
void writeTGA (char *name, unsigned char *buff, int w, int h) {
	unsigned char *header = (unsigned char *)"\x00\x00\x02\x00\x00\x00\x00\x00\x00\x00\x00\x00";
	unsigned char info[6];
	FILE *s;

	s = fopen (name, "w");
	
	fwrite (header, sizeof (char), 12, s);
	
	info[0] = w;
	info[1] = (w >> 8);
	info[2] = h;
	info[3] = (h >> 8);
	info[4] = 24;
	info[5] = 0;
	
	fwrite (&info, sizeof (char), 6, s);
	
	makeBGR (buff, w * h);

	fwrite (buff, sizeof (char), w * h * 3, s);

	fclose (s);
}
/*
	Function -- screenShot
	Read the current image data from the frame buffer and write it to a file
*/
int screenShot (char *fName, int winW, int winH) {
	unsigned char *fBuffer;

	fBuffer = (unsigned char *)malloc (winW * winH * 3);
	
	if (fBuffer == NULL)
		return 0;

	glReadPixels (0, 0, winW, winH, GL_RGB, GL_UNSIGNED_BYTE, fBuffer);

	writeTGA (fName, fBuffer, winW, winH);

	free (fBuffer);

	return 1;
}
/*
 * $Log: screenShot.c,v $
 * Revision 1.2  2000/03/08 13:09:21  eilemann
 * inserted cvs log in all files
 *
 */
